# Exponential functions

xtensor provides the following exponential functions for xexpressions:

Defined in `xtensor/xmath.hpp`

template<class E>
inline auto xt::exp(E &&e) noexcept -> detail::xfunction_type_t<math::exp_fun, E>

  Natural exponential function.

  Returns an xfunction for the element-wise natural exponential of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::exp2(E &&e) noexcept -> detail::xfunction_type_t<math::exp2_fun, E>

  Base 2 exponential function.

  Returns an xfunction for the element-wise base 2 exponential of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::expm1(E &&e) noexcept -> detail::xfunction_type_t<math::expm1_fun, E>

  Natural exponential minus one function.

  Returns an xfunction for the element-wise natural exponential of e, minus 1.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::log(E &&e) noexcept -> detail::xfunction_type_t<math::log_fun, E>

  Natural logarithm function.

  Returns an xfunction for the element-wise natural logarithm of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::log2(E &&e) noexcept -> detail::xfunction_type_t<math::log2_fun, E>

  Base 2 logarithm function.

  Returns an xfunction for the element-wise base 2 logarithm of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::log10(E &&e) noexcept -> detail::xfunction_type_t<math::log10_fun, E>

  Base 10 logarithm function.

  Returns an xfunction for the element-wise base 10 logarithm of e.

  Parameters

    e – an xexpression

  Returns

    an xfunction

template<class E>
inline auto xt::log1p(E &&e) noexcept -> detail::xfunction_type_t<math::log1p_fun, E>

  Natural logarithm of one plus function.

  Returns an xfunction for the element-wise natural logarithm of e, plus 1.

  Parameters

    e – an xexpression

  Returns

    an xfunction